commit:     46ca7183c78092168fe5d8d3ea804807ddaffbe9
Author:     Paul Zander <negril.nx+gentoo <AT> gmail <DOT> com>
AuthorDate: Tue Nov 25 16:24:56 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Dec 22 11:40:34 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=46ca7183

sys-cluster/openmpi: add 5.0.9

Closes: https://bugs.gentoo.org/966237
Signed-off-by: Paul Zander <negril.nx+gentoo <AT> gmail.com>
Part-of: https://github.com/gentoo/gentoo/pull/45111
Signed-off-by: Sam James <sam <AT> gentoo.org>

 sys-cluster/openmpi/Manifest             |   1 +
 sys-cluster/openmpi/openmpi-5.0.9.ebuild | 152 +++++++++++++++++++++++++++++++
 2 files changed, 153 insertions(+)

diff --git a/sys-cluster/openmpi/Manifest b/sys-cluster/openmpi/Manifest
index cca399c3a1f7..d78c78c387f9 100644
--- a/sys-cluster/openmpi/Manifest
+++ b/sys-cluster/openmpi/Manifest
@@ -1,3 +1,4 @@
 DIST openmpi-4.1.6.tar.bz2 10017002 BLAKE2B 
4f119e1ed9b8787f0f860295ab1721fe2fd5300b8e182230a9eba3a864680b02bbd30618cc6d798a693a121626fc0ad5f447144d9ba91becb734f1a530d7a23a
 SHA512 
0ef3240f9c436fb19b67e836cac376eafeb7825d12de3387dad04329dee9f182799d17d785ea23eba763810f479015bb5230593c28950b616b2f0aa1c0a81e71
 DIST openmpi-5.0.6.tar.bz2 30331784 BLAKE2B 
72418c4d2cdc0628214e0c2db2e8d2dd52234a3888d7344eff23576b19de94d4cb74b168120d72cedeea8c835db363d83b61319fcdf13277c541003606f4558a
 SHA512 
097f7bb18d506b362f16d46df308b387e3173068ba8688739db756919453e1fe947c6d8c2e098481617d8c6bbecb8990002db42f284b1732a80ef3edaaa29f20
 DIST openmpi-5.0.8.tar.bz2 30293034 BLAKE2B 
610df6519323c9d08feccdd3d5b9d8a36cbed8ade7e31ca340e31aa0e21f6fc3ab6534c16a1660d9af53594d6836ed54fdd910202f22175d8517dc5193e1cd9c
 SHA512 
de9128edaa1886f90f1452b8cee3c3962d7666beed96d7b95c601278c2debc7d7efecc9403792d428ce12131ce30416d6bc6bb657fb1a5490f53c6b6e369b080
+DIST openmpi-5.0.9.tar.bz2 30360927 BLAKE2B 
f6c822f9bcbf5cbdb508cf70a6fcb717630157c6753bda1f01dc378617971744600b46052baa5a89e5964240f03c241cd41f7b119ce7e084704cd3a71eb8637e
 SHA512 
d7f700d6f412c6ff6d2f0d71da6dff9c88039e4c0693ff4f68c9cf4e9705744c362ac7afa916c7d7c6389832a1c8b4681b567a8521df3abdab22c581157cc5d0

diff --git a/sys-cluster/openmpi/openmpi-5.0.9.ebuild 
b/sys-cluster/openmpi/openmpi-5.0.9.ebuild
new file mode 100644
index 000000000000..50f6133f6b94
--- /dev/null
+++ b/sys-cluster/openmpi/openmpi-5.0.9.ebuild
@@ -0,0 +1,152 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+FORTRAN_NEEDED=fortran
+inherit cuda flag-o-matic fortran-2 libtool
+
+MY_P=${P/-mpi}
+
+IUSE_OPENMPI_FABRICS="
+       openmpi_fabrics_ofed
+       openmpi_fabrics_knem"
+
+IUSE_OPENMPI_RM="
+       openmpi_rm_pbs
+       openmpi_rm_slurm"
+
+DESCRIPTION="A high-performance message passing library (MPI)"
+HOMEPAGE="https://www.open-mpi.org";
+SRC_URI="https://www.open-mpi.org/software/ompi/v$(ver_cut 
1-2)/downloads/${MY_P}.tar.bz2"
+S="${WORKDIR}/${MY_P}"
+
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~amd64 -arm ~arm64 -ppc ~ppc64 -x86"
+IUSE="cma cuda fortran peruse romio valgrind
+       ${IUSE_OPENMPI_FABRICS} ${IUSE_OPENMPI_RM}"
+
+REQUIRED_USE="
+       openmpi_rm_slurm? ( !openmpi_rm_pbs )
+       openmpi_rm_pbs? ( !openmpi_rm_slurm )
+"
+
+# !dev-lang/pcc # 951474 file collision in /usr/bin/pcc
+RDEPEND="
+       !dev-lang/pcc
+       !sys-cluster/mpich
+       !sys-cluster/mpich2
+       !sys-cluster/nullmpi
+       >=dev-libs/libevent-2.0.22:=[threads(+)]
+       >=sys-apps/hwloc-2.0.2:=
+       sys-cluster/pmix
+       sys-cluster/prrte:=
+       >=virtual/zlib-1.2.8-r1:=
+       cuda? (
+               >=dev-util/nvidia-cuda-toolkit-6.5.19-r1:=
+               sys-cluster/ucx
+               x11-drivers/nvidia-drivers
+       )
+       openmpi_fabrics_ofed? ( sys-cluster/rdma-core )
+       openmpi_fabrics_knem? ( sys-cluster/knem )
+       openmpi_rm_pbs? ( sys-cluster/torque )
+       openmpi_rm_slurm? ( sys-cluster/slurm )
+"
+DEPEND="${RDEPEND}
+       valgrind? ( dev-debug/valgrind )"
+
+PATCHES=(
+       "${FILESDIR}/${PN}-5.0.8-braces-around-scalar-initializer.patch"
+)
+
+pkg_setup() {
+       fortran-2_pkg_setup
+
+       elog
+       elog "OpenMPI has an overwhelming count of configuration options."
+       elog "Don't forget the EXTRA_ECONF environment variable can let you"
+       elog "specify configure options if you find them necessary."
+       elog
+}
+
+src_prepare() {
+       default
+       elibtoolize
+
+       # Avoid test which ends up looking at system mounts
+       echo "int main() { return 0; }" > test/util/opal_path_nfs.c || die
+
+       # Necessary for scalibility, see
+       # http://www.open-mpi.org/community/lists/users/2008/09/6514.php
+       echo 'oob_tcp_listen_mode = listen_thread' \
+               >> opal/etc/openmpi-mca-params.conf || die
+}
+
+src_configure() {
+       # -Werror=lto-type-mismatch, -Werror=strict-aliasing
+       # The former even prevents successfully running ./configure, but both 
appear
+       # at `make` time as well.
+       # https://bugs.gentoo.org/913040
+       # https://github.com/open-mpi/ompi/issues/12674
+       # https://github.com/open-mpi/ompi/issues/12675
+       append-flags -fno-strict-aliasing
+       filter-lto
+
+       local myconf=(
+               --disable-mpi-java
+               # configure takes a looooong time, but upstream currently force
+               # constraints on caching:
+               # 
https://github.com/open-mpi/ompi/blob/9eec56222a5c98d13790c9ee74877f1562ac27e8/config/opal_config_subdir.m4#L118
+               # so no --cache-dir for now.
+               --enable-mpi-fortran=$(usex fortran all no)
+               --enable-prte-prefix-by-default
+               --enable-pretty-print-stacktrace
+
+               --sysconfdir="${EPREFIX}/etc/${PN}"
+
+               --with-hwloc=external
+               --with-libevent=external
+               --with-prrte=external
+
+               # Originally supposed to be re-enabled for 5.0!
+               # See 
https://github.com/open-mpi/ompi/issues/9697#issuecomment-1003746357
+               # and https://bugs.gentoo.org/828123#c14
+               #
+               # However as of 5.0.3 the docs still say:
+               #
+               #   As such, supporting data heterogeneity is a feature that 
has fallen
+               #   into disrepair and is currently known to be broken in this 
release
+               #   of Open MPI.
+               --disable-heterogeneous
+
+               --enable-ipv6
+               $(use_enable peruse)
+               $(use_enable romio io-romio)
+
+               $(use_with cma)
+
+               $(use_with cuda cuda "${CUDA_PATH:-${ESYSROOT}/opt/cuda}")
+               $(use_with valgrind)
+               $(use_with openmpi_fabrics_knem knem "${EPREFIX}"/usr)
+               $(use_with openmpi_rm_pbs tm)
+               $(use_with openmpi_rm_slurm slurm)
+       )
+
+       CONFIG_SHELL="${BROOT}"/bin/bash econf "${myconf[@]}"
+}
+
+src_compile() {
+       emake V=1
+}
+
+src_test() {
+       emake -C test check
+}
+
+src_install() {
+       default
+
+       # Remove la files, no static libs are installed and we have pkg-config
+       find "${ED}" -name '*.la' -delete || die
+}

Reply via email to